'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FileUploader = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _desc, _value, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _coreDecorators = require('core-decorators');

var _reactComponentUtils = require('@ciscospark/react-component-utils');

var _reduxModuleActivity = require('@ciscospark/redux-module-activity');

var _reactComponentAddFileButton = require('@ciscospark/react-component-add-file-button');

var _reactComponentAddFileButton2 = _interopRequireDefault(_reactComponentAddFileButton);

var _reactComponentFileStagingArea = require('@ciscospark/react-component-file-staging-area');

var _reactComponentFileStagingArea2 = _interopRequireDefault(_reactComponentFileStagingArea);

var _selectors = require('./selectors');

var _selectors2 = _interopRequireDefault(_selectors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var styles = {
  'buttonContainer': 'buttonContainer--3MeCz'
}; // @related-file ./styles.css

var injectedPropTypes = {
  activity: _propTypes2.default.object.isRequired,
  conversation: _propTypes2.default.object.isRequired,
  spark: _propTypes2.default.object.isRequired,
  addFiles: _propTypes2.default.func.isRequired,
  removeFile: _propTypes2.default.func.isRequired
};

var propTypes = (0, _extends3.default)({
  onSubmit: _propTypes2.default.func.isRequired
}, injectedPropTypes);

var FileUploader = exports.FileUploader = (_class = function (_Component) {
  (0, _inherits3.default)(FileUploader, _Component);

  function FileUploader() {
    (0, _classCallCheck3.default)(this, FileUploader);
    return (0, _possibleConstructorReturn3.default)(this, (FileUploader.__proto__ || Object.getPrototypeOf(FileUploader)).apply(this, arguments));
  }

  (0, _createClass3.default)(FileUploader, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var props = this.props;

      return nextProps.activity !== props.activity;
    }
  }, {
    key: 'handleFileChange',
    value: function handleFileChange(e) {
      e.stopPropagation();
      e.preventDefault();

      if (e.target.files.length) {
        var props = this.props;
        var activity = props.activity,
            conversation = props.conversation,
            spark = props.spark;


        var files = (0, _reactComponentUtils.constructFiles)(e.target.files);
        props.addFiles(conversation, activity, files, spark);

        // Clear the value of the input so the same file can be added again.
        e.target.value = '';
      }
    }
  }, {
    key: 'handleFileRemove',
    value: function handleFileRemove(id) {
      var props = this.props;

      props.removeFile(id, props.activity);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          onSubmit = _props.onSubmit,
          activity = _props.activity;

      var files = activity.get('files');

      var stagingArea = void 0;
      if (files && files.count()) {
        stagingArea = _react2.default.createElement(_reactComponentFileStagingArea2.default, {
          files: files,
          onFileRemove: this.handleFileRemove,
          onSubmit: onSubmit
        });
      }

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ciscospark-file-uploader-container', styles.container) },
        stagingArea,
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ciscospark-button-container', styles.buttonContainer) },
          _react2.default.createElement(_reactComponentAddFileButton2.default, { onChange: this.handleFileChange })
        )
      );
    }
  }]);
  return FileUploader;
}(_react.Component), (_applyDecoratedDescriptor(_class.prototype, 'handleFileChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleFileChange'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'handleFileRemove', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class.prototype, 'handleFileRemove'), _class.prototype)), _class);


FileUploader.propTypes = propTypes;

exports.default = (0, _reactRedux.connect)(_selectors2.default, function (dispatch) {
  return (0, _redux.bindActionCreators)({
    addFiles: _reduxModuleActivity.addFiles,
    removeFile: _reduxModuleActivity.removeFile
  }, dispatch);
})(FileUploader);