import {createSelector} from 'reselect';

const getSpark = (state, ownProps) => ownProps.sparkInstance || state.spark.get('spark');
const getConversation = (state) => state.conversation;
const getActivity = (state) => state.activity;

const getContainerProps = createSelector(
  [getSpark, getConversation, getActivity],
  (spark, conversation, activity) => (
    {
      spark,
      conversation,
      activity
    }
  )
);

export default getContainerProps;
